// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: gateway/rooms/v1/rooms.proto

package roomsv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/gateway/pkg/gen/gateway/rooms/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// RoomsServiceName is the fully-qualified name of the RoomsService service.
	RoomsServiceName = "gateway.rooms.v1.RoomsService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// RoomsServiceCreateRoomProcedure is the fully-qualified name of the RoomsService's CreateRoom RPC.
	RoomsServiceCreateRoomProcedure = "/gateway.rooms.v1.RoomsService/CreateRoom"
	// RoomsServiceEditRoomProcedure is the fully-qualified name of the RoomsService's EditRoom RPC.
	RoomsServiceEditRoomProcedure = "/gateway.rooms.v1.RoomsService/EditRoom"
	// RoomsServiceJoinRoomProcedure is the fully-qualified name of the RoomsService's JoinRoom RPC.
	RoomsServiceJoinRoomProcedure = "/gateway.rooms.v1.RoomsService/JoinRoom"
	// RoomsServiceLeaveRoomProcedure is the fully-qualified name of the RoomsService's LeaveRoom RPC.
	RoomsServiceLeaveRoomProcedure = "/gateway.rooms.v1.RoomsService/LeaveRoom"
	// RoomsServiceCheckIfRoomExistsProcedure is the fully-qualified name of the RoomsService's
	// CheckIfRoomExists RPC.
	RoomsServiceCheckIfRoomExistsProcedure = "/gateway.rooms.v1.RoomsService/CheckIfRoomExists"
	// RoomsServiceBanUserFromRoomProcedure is the fully-qualified name of the RoomsService's
	// BanUserFromRoom RPC.
	RoomsServiceBanUserFromRoomProcedure = "/gateway.rooms.v1.RoomsService/BanUserFromRoom"
	// RoomsServiceUnbanUserFromRoomProcedure is the fully-qualified name of the RoomsService's
	// UnbanUserFromRoom RPC.
	RoomsServiceUnbanUserFromRoomProcedure = "/gateway.rooms.v1.RoomsService/UnbanUserFromRoom"
	// RoomsServiceGetQuestionCountProcedure is the fully-qualified name of the RoomsService's
	// GetQuestionCount RPC.
	RoomsServiceGetQuestionCountProcedure = "/gateway.rooms.v1.RoomsService/GetQuestionCount"
	// RoomsServiceStartMatchProcedure is the fully-qualified name of the RoomsService's StartMatch RPC.
	RoomsServiceStartMatchProcedure = "/gateway.rooms.v1.RoomsService/StartMatch"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	roomsServiceServiceDescriptor                 = v1.File_gateway_rooms_v1_rooms_proto.Services().ByName("RoomsService")
	roomsServiceCreateRoomMethodDescriptor        = roomsServiceServiceDescriptor.Methods().ByName("CreateRoom")
	roomsServiceEditRoomMethodDescriptor          = roomsServiceServiceDescriptor.Methods().ByName("EditRoom")
	roomsServiceJoinRoomMethodDescriptor          = roomsServiceServiceDescriptor.Methods().ByName("JoinRoom")
	roomsServiceLeaveRoomMethodDescriptor         = roomsServiceServiceDescriptor.Methods().ByName("LeaveRoom")
	roomsServiceCheckIfRoomExistsMethodDescriptor = roomsServiceServiceDescriptor.Methods().ByName("CheckIfRoomExists")
	roomsServiceBanUserFromRoomMethodDescriptor   = roomsServiceServiceDescriptor.Methods().ByName("BanUserFromRoom")
	roomsServiceUnbanUserFromRoomMethodDescriptor = roomsServiceServiceDescriptor.Methods().ByName("UnbanUserFromRoom")
	roomsServiceGetQuestionCountMethodDescriptor  = roomsServiceServiceDescriptor.Methods().ByName("GetQuestionCount")
	roomsServiceStartMatchMethodDescriptor        = roomsServiceServiceDescriptor.Methods().ByName("StartMatch")
)

// RoomsServiceClient is a client for the gateway.rooms.v1.RoomsService service.
type RoomsServiceClient interface {
	// RPC to create a new room
	CreateRoom(context.Context, *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error)
	// RPC to edit an existing room
	EditRoom(context.Context, *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error)
	// RPC to join an existing room
	JoinRoom(context.Context, *connect.Request[v1.JoinRoomRequest]) (*connect.Response[v1.JoinRoomResponse], error)
	// RPC to leave from room
	LeaveRoom(context.Context, *connect.Request[v1.LeaveRoomRequest]) (*connect.Response[v1.LeaveRoomResponse], error)
	// RPC to check if a room exists
	CheckIfRoomExists(context.Context, *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error)
	// RPC to ban a user from a room
	BanUserFromRoom(context.Context, *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error)
	// RPC to unban a user from a room
	UnbanUserFromRoom(context.Context, *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error)
	// RPC to get the question count in a room
	GetQuestionCount(context.Context, *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error)
	// RPC to start a match in a room
	StartMatch(context.Context, *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error)
}

// NewRoomsServiceClient constructs a client for the gateway.rooms.v1.RoomsService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewRoomsServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) RoomsServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &roomsServiceClient{
		createRoom: connect.NewClient[v1.CreateRoomRequest, v1.CreateRoomResponse](
			httpClient,
			baseURL+RoomsServiceCreateRoomProcedure,
			connect.WithSchema(roomsServiceCreateRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		editRoom: connect.NewClient[v1.EditRoomRequest, v1.EditRoomResponse](
			httpClient,
			baseURL+RoomsServiceEditRoomProcedure,
			connect.WithSchema(roomsServiceEditRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		joinRoom: connect.NewClient[v1.JoinRoomRequest, v1.JoinRoomResponse](
			httpClient,
			baseURL+RoomsServiceJoinRoomProcedure,
			connect.WithSchema(roomsServiceJoinRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		leaveRoom: connect.NewClient[v1.LeaveRoomRequest, v1.LeaveRoomResponse](
			httpClient,
			baseURL+RoomsServiceLeaveRoomProcedure,
			connect.WithSchema(roomsServiceLeaveRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		checkIfRoomExists: connect.NewClient[v1.CheckIfRoomExistsRequest, v1.CheckIfRoomExistsResponse](
			httpClient,
			baseURL+RoomsServiceCheckIfRoomExistsProcedure,
			connect.WithSchema(roomsServiceCheckIfRoomExistsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		banUserFromRoom: connect.NewClient[v1.BanUserFromRoomRequest, v1.BanUserFromRoomResponse](
			httpClient,
			baseURL+RoomsServiceBanUserFromRoomProcedure,
			connect.WithSchema(roomsServiceBanUserFromRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		unbanUserFromRoom: connect.NewClient[v1.UnbanUserFromRoomRequest, v1.UnbanUserFromRoomResponse](
			httpClient,
			baseURL+RoomsServiceUnbanUserFromRoomProcedure,
			connect.WithSchema(roomsServiceUnbanUserFromRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getQuestionCount: connect.NewClient[v1.GetQuestionCountRequest, v1.GetQuestionCountResponse](
			httpClient,
			baseURL+RoomsServiceGetQuestionCountProcedure,
			connect.WithSchema(roomsServiceGetQuestionCountMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		startMatch: connect.NewClient[v1.StartMatchRequest, v1.StartMatchResponse](
			httpClient,
			baseURL+RoomsServiceStartMatchProcedure,
			connect.WithSchema(roomsServiceStartMatchMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// roomsServiceClient implements RoomsServiceClient.
type roomsServiceClient struct {
	createRoom        *connect.Client[v1.CreateRoomRequest, v1.CreateRoomResponse]
	editRoom          *connect.Client[v1.EditRoomRequest, v1.EditRoomResponse]
	joinRoom          *connect.Client[v1.JoinRoomRequest, v1.JoinRoomResponse]
	leaveRoom         *connect.Client[v1.LeaveRoomRequest, v1.LeaveRoomResponse]
	checkIfRoomExists *connect.Client[v1.CheckIfRoomExistsRequest, v1.CheckIfRoomExistsResponse]
	banUserFromRoom   *connect.Client[v1.BanUserFromRoomRequest, v1.BanUserFromRoomResponse]
	unbanUserFromRoom *connect.Client[v1.UnbanUserFromRoomRequest, v1.UnbanUserFromRoomResponse]
	getQuestionCount  *connect.Client[v1.GetQuestionCountRequest, v1.GetQuestionCountResponse]
	startMatch        *connect.Client[v1.StartMatchRequest, v1.StartMatchResponse]
}

// CreateRoom calls gateway.rooms.v1.RoomsService.CreateRoom.
func (c *roomsServiceClient) CreateRoom(ctx context.Context, req *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error) {
	return c.createRoom.CallUnary(ctx, req)
}

// EditRoom calls gateway.rooms.v1.RoomsService.EditRoom.
func (c *roomsServiceClient) EditRoom(ctx context.Context, req *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error) {
	return c.editRoom.CallUnary(ctx, req)
}

// JoinRoom calls gateway.rooms.v1.RoomsService.JoinRoom.
func (c *roomsServiceClient) JoinRoom(ctx context.Context, req *connect.Request[v1.JoinRoomRequest]) (*connect.Response[v1.JoinRoomResponse], error) {
	return c.joinRoom.CallUnary(ctx, req)
}

// LeaveRoom calls gateway.rooms.v1.RoomsService.LeaveRoom.
func (c *roomsServiceClient) LeaveRoom(ctx context.Context, req *connect.Request[v1.LeaveRoomRequest]) (*connect.Response[v1.LeaveRoomResponse], error) {
	return c.leaveRoom.CallUnary(ctx, req)
}

// CheckIfRoomExists calls gateway.rooms.v1.RoomsService.CheckIfRoomExists.
func (c *roomsServiceClient) CheckIfRoomExists(ctx context.Context, req *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error) {
	return c.checkIfRoomExists.CallUnary(ctx, req)
}

// BanUserFromRoom calls gateway.rooms.v1.RoomsService.BanUserFromRoom.
func (c *roomsServiceClient) BanUserFromRoom(ctx context.Context, req *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error) {
	return c.banUserFromRoom.CallUnary(ctx, req)
}

// UnbanUserFromRoom calls gateway.rooms.v1.RoomsService.UnbanUserFromRoom.
func (c *roomsServiceClient) UnbanUserFromRoom(ctx context.Context, req *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error) {
	return c.unbanUserFromRoom.CallUnary(ctx, req)
}

// GetQuestionCount calls gateway.rooms.v1.RoomsService.GetQuestionCount.
func (c *roomsServiceClient) GetQuestionCount(ctx context.Context, req *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error) {
	return c.getQuestionCount.CallUnary(ctx, req)
}

// StartMatch calls gateway.rooms.v1.RoomsService.StartMatch.
func (c *roomsServiceClient) StartMatch(ctx context.Context, req *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error) {
	return c.startMatch.CallUnary(ctx, req)
}

// RoomsServiceHandler is an implementation of the gateway.rooms.v1.RoomsService service.
type RoomsServiceHandler interface {
	// RPC to create a new room
	CreateRoom(context.Context, *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error)
	// RPC to edit an existing room
	EditRoom(context.Context, *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error)
	// RPC to join an existing room
	JoinRoom(context.Context, *connect.Request[v1.JoinRoomRequest]) (*connect.Response[v1.JoinRoomResponse], error)
	// RPC to leave from room
	LeaveRoom(context.Context, *connect.Request[v1.LeaveRoomRequest]) (*connect.Response[v1.LeaveRoomResponse], error)
	// RPC to check if a room exists
	CheckIfRoomExists(context.Context, *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error)
	// RPC to ban a user from a room
	BanUserFromRoom(context.Context, *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error)
	// RPC to unban a user from a room
	UnbanUserFromRoom(context.Context, *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error)
	// RPC to get the question count in a room
	GetQuestionCount(context.Context, *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error)
	// RPC to start a match in a room
	StartMatch(context.Context, *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error)
}

// NewRoomsServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewRoomsServiceHandler(svc RoomsServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	roomsServiceCreateRoomHandler := connect.NewUnaryHandler(
		RoomsServiceCreateRoomProcedure,
		svc.CreateRoom,
		connect.WithSchema(roomsServiceCreateRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceEditRoomHandler := connect.NewUnaryHandler(
		RoomsServiceEditRoomProcedure,
		svc.EditRoom,
		connect.WithSchema(roomsServiceEditRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceJoinRoomHandler := connect.NewUnaryHandler(
		RoomsServiceJoinRoomProcedure,
		svc.JoinRoom,
		connect.WithSchema(roomsServiceJoinRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceLeaveRoomHandler := connect.NewUnaryHandler(
		RoomsServiceLeaveRoomProcedure,
		svc.LeaveRoom,
		connect.WithSchema(roomsServiceLeaveRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceCheckIfRoomExistsHandler := connect.NewUnaryHandler(
		RoomsServiceCheckIfRoomExistsProcedure,
		svc.CheckIfRoomExists,
		connect.WithSchema(roomsServiceCheckIfRoomExistsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceBanUserFromRoomHandler := connect.NewUnaryHandler(
		RoomsServiceBanUserFromRoomProcedure,
		svc.BanUserFromRoom,
		connect.WithSchema(roomsServiceBanUserFromRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceUnbanUserFromRoomHandler := connect.NewUnaryHandler(
		RoomsServiceUnbanUserFromRoomProcedure,
		svc.UnbanUserFromRoom,
		connect.WithSchema(roomsServiceUnbanUserFromRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceGetQuestionCountHandler := connect.NewUnaryHandler(
		RoomsServiceGetQuestionCountProcedure,
		svc.GetQuestionCount,
		connect.WithSchema(roomsServiceGetQuestionCountMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceStartMatchHandler := connect.NewUnaryHandler(
		RoomsServiceStartMatchProcedure,
		svc.StartMatch,
		connect.WithSchema(roomsServiceStartMatchMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/gateway.rooms.v1.RoomsService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case RoomsServiceCreateRoomProcedure:
			roomsServiceCreateRoomHandler.ServeHTTP(w, r)
		case RoomsServiceEditRoomProcedure:
			roomsServiceEditRoomHandler.ServeHTTP(w, r)
		case RoomsServiceJoinRoomProcedure:
			roomsServiceJoinRoomHandler.ServeHTTP(w, r)
		case RoomsServiceLeaveRoomProcedure:
			roomsServiceLeaveRoomHandler.ServeHTTP(w, r)
		case RoomsServiceCheckIfRoomExistsProcedure:
			roomsServiceCheckIfRoomExistsHandler.ServeHTTP(w, r)
		case RoomsServiceBanUserFromRoomProcedure:
			roomsServiceBanUserFromRoomHandler.ServeHTTP(w, r)
		case RoomsServiceUnbanUserFromRoomProcedure:
			roomsServiceUnbanUserFromRoomHandler.ServeHTTP(w, r)
		case RoomsServiceGetQuestionCountProcedure:
			roomsServiceGetQuestionCountHandler.ServeHTTP(w, r)
		case RoomsServiceStartMatchProcedure:
			roomsServiceStartMatchHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedRoomsServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedRoomsServiceHandler struct{}

func (UnimplementedRoomsServiceHandler) CreateRoom(context.Context, *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.CreateRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) EditRoom(context.Context, *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.EditRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) JoinRoom(context.Context, *connect.Request[v1.JoinRoomRequest]) (*connect.Response[v1.JoinRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.JoinRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) LeaveRoom(context.Context, *connect.Request[v1.LeaveRoomRequest]) (*connect.Response[v1.LeaveRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.LeaveRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) CheckIfRoomExists(context.Context, *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.CheckIfRoomExists is not implemented"))
}

func (UnimplementedRoomsServiceHandler) BanUserFromRoom(context.Context, *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.BanUserFromRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) UnbanUserFromRoom(context.Context, *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.UnbanUserFromRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) GetQuestionCount(context.Context, *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.GetQuestionCount is not implemented"))
}

func (UnimplementedRoomsServiceHandler) StartMatch(context.Context, *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.rooms.v1.RoomsService.StartMatch is not implemented"))
}
